=begin
**
** parser.rb
** 14/AUG/2007
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**   Contains the Parser class that splits user input (text lines) and redirects
** execution flow to the module that can handle the request.
**
** Version:
**  v1.0 [14/August/2007]: first released
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end

module Commands
  # Main user input parsing class. It receives user input (lines of text) and
  # forwards the request to the corresponding dispatcher.
  #
  class Parser
    #===================================================== public methods
    public   
    #----------------------------------------------------- class methods
    
    # Parse a single line of text. Cycles through the list of 
    # registered dispatchers. When a dispatcher is found to be able to handle
    # the user's request, the execution is passed to it.
    def parse(text)
      dispatch text.split.shift, *text.split
    end

    # In the same way Parser.parse, this method dispatches a command to the
    # specific module that can handle it.
    # 
    # This function is intended to be used programatically while Parser.parse
    # is meant to be used with direct user input.
    def run2(cmd, *params)  
      raise 're-think!'
      #dispatch cmd, *(params.unshift cmd)
    end
  end
end

