=begin
**
** namespace.rb
** 16/AUG/2007
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**   Contains the set of clases that constitute the Model layer of the client.
** SOAP requests will be performed to populate this classes with the latest
** information available from the server.
**
** Version:
**  v1.0 [16/August/2007]: first released
**  v1.1 [05/February/2008]: implement the encapsulation concept, this class
**           holds a copy of the latest SOAP object obtained from the server
**           and provides access to the contents of the so called 'knowledge
**           base'.
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end
module Core
  #
  #
  class Model
    include ModelInterface

    #===================================================== private methods
    private

    #===================================================== public methods
    public
    def initialize
      @local_kb = nil
      @categories = []
    end
    
    def refresh_with(new_model)
      @local_kb = new_model
    end
    
    def revision
      return 0 if @local_kb.nil?
      @local_kb.revision
    end
    
    def hosts() @local_kb.hosts end
    def categories() @local_kb.categories end
    def protocols() @local_kb.protocols end
  end

end