=begin
**
** console.rb
** 30/JUL/2007
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**   Simple command line interface that implements the View interface.
** 
** Version:
**  v1.0 [30/July/2007]: first released
**  v1.1 [06/February/2008]: 
**    - sort out the header comments. 
**    - addapt the code to the MVC architecture. Adapt to the View interface.
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end
require 'irb/input-method'
require 'commands'

# Different user interfaces will be grouped under this module.
module Ui
  module Console
    class CLI
      include Core::ViewInterface
      
      def initialize
        @io = IRB::ReadlineInputMethod.new
        @io.prompt = 'dradis> '
        @controller = nil
        
        trap('SIGINT') do
          signal_handle
        end
        
      end
      
      def signal_handle
        puts '^C. please use: quit'
      end
      
      def run
        @continue = true
        while @continue
          line = @io.gets.chomp
          puts @controller.parse_command(line)
        end
      end
    
      def setup(new_controller)
        @controller = new_controller
      end
      
      def teardown
        puts 'closing dradis console...'
        @continue = false
      end
    end
  end
end