=begin
**
** window.rb
** 01/FEB/2008
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**  Main wxWidgets application window
**
** Version:
**  v1.0 [01/February/2008]: first released
**  v1.1 [20/February/2008]: add an :invalid HTML code to be used by the
**         NotesBrowser.
**  v1.2 [29/February/2008]: update the :home html to 2008 :)
**  v1.3 [03/March/2008]: update the HTML[:home] message to reflect dradis 1.2
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end

module Ui
  # Interface to a widget that can be used to browse and display notes for
  # different annotatable object types.
  module NotesBrowserInterface        
    HTML = {
      :home => '<center><br/><img src="ui/qt/images/dradis.jpg"><h1>dradis 1.2</h1>etdsoft \'08</center>',
      :bar => '<div><div>actions: <a href="add/#type#/#uid#">add note</a></div><div>show:#catlist# (<a href="filter/all">all</a>)</div></div>',
      :invalid => '<center><br/><img src="ui/qt/images/dradis.jpg"><p>please, wait until the new revision is downloaded from the server...</p></center>'
    }
      
    # Invalidate the current view as a result of an action performed by the
    # user (i.e. add a new note, edit the current note, etc.). The widget
    # should display some behaviour indicating that the current view is no
    # longer valid and the user should wait until content is refreshed from
    # the server.
    def invalidate!() raise 'unimplemented!'; end
        
    def reload() raise 'unimplemented!'; end
    
    # Display the default page. When a model update is received, the notes
    # browser should be brought back to the default page.
    def home() raise 'unimplemented!'; end
        
    # Given a set of notes (_note_list_) the widge should display them.
    # Other attributes are passed to the widget in order to be returned
    # when the widget signals *editNote* or *addNote*.
    def show_notes(annotatable_type, annotatable_id, note_list) 
      raise 'unimplemented!'; 
    end
  end

  # All custom controls/widgets of the UI that are used to display host/service
  # information should implement the following interface.
  module HostsBrowserInterface
    
    # Refresh the contents of the control with the new information provided
    # by the model.
    def update_view(model) raise 'unimplemented!' end
  end

  # Controls acting as a command line console should implement this interface
  # to be able to interact with the main window.
  module ConsoleInterface
    def append(line) raise 'unimplemented!' end
  end
end
